
;
; The Doctor presents...
;
;   BatWrite.Com  : Extended batch file output utility.
;

code      segment   byte      'Code'
          assume    CS:Code

          org       00100h

Start:    push      CS
          pop       DS
          mov       SI,00080h
          lodsb
          mov       CL,AL
          xor       CH,CH
          cmp       CX,00001h
          jng       DoInfo
          dec       CX
          lodsb
WriteL:   lodsb
          cmp       AL,024h
          je        SpChar
PrintIt:  mov       DL,AL
          mov       AH,002h
          push      CX
          int       021h
          pop       CX
NoPrint:  dec       CX
          cmp       CX,00000h
          jne       WriteL
AllDone:  mov       AX,04C00h
          int       021h

SpChar:   dec       CX
          cmp       CX,00000h
          jng       AllDone
          lodsb
          push      CX
          push      BX
          push      AX
          xor       AH,AH
          mov       BX,offset XLTable-1
SpLoop:   cmp       AH,AL
          je        WrSpChr
          inc       AH
SpLoop1:  inc       BX
          cmp       byte ptr [BX],000h
          jne       SpLoop1
          jmp short SpLoop

WrSpChr:  inc       BX
          mov       AL,[BX]
          cmp       AL,0
          je        ExSpChr
          push      AX
          push      BX
          push      DX
          mov       DL,AL
          mov       AH,002h
          int       021h
          pop       DX
          pop       BX
          pop       AX
          jmp       WrSpChr

ExSpChr:  pop       AX
          pop       BX
          pop       CX
          jmp short NoPrint

DoInfo:   mov       BX,(offset MyTitle)-1
InfoLoop: inc       BX
          mov       DL,CS:[BX]
          cmp       DL,000h
          je        AllDone
          mov       AH,002h
          int       021h
          jmp short InfoLoop

          db        "Data table begins here :"

;
; This is a ASCIIZ string based translation table, entered in order.
; First entry is $[0], last entry is $[255].  All entries are to be terminated
; with a zero byte.  Table is dynamic : no changes needed to above code to
; change any entry length.  Note that all entries, including null entries,
; MUST be terminated wtih a zero byte, and that no entry may contain a zero
; byte, for obvious reasons.  Program max size is $FE00 bytes, due to certain
; limitations on both .COM files and the table-search method.
;
; This comes to you with [1..31],[128..255] defined as themselves.  Note that
; all 256 entries MUST be defined, otherwise an infinite loop is possible.
; The pre-defined entries which are changed are...
;
;      Text  Output                     Comment
;      ----  -------------------------  -------------------------
;       $^@                             No output (null)
;       $    ^I                         TAB
;       $!                             Open exclamation
;       $"   `                          Open quote
;       $#                             Pound
;       $$   $                          Dollar / String
;       $%   %                          Percent
;       $&   &                          And
;       $'   '                          Apostrophe / Close quote
;       $(                             Open quote in some countries
;       $)                             Close quote in some countries
;       $*                             Delta
;       $+   +                          Plus
;       $,   ,                          Comma
;       $-                             Always equal / Definition
;       $.   .                          Period
;       $/   /                          Forward slash
;       $0                              0% grey
;       $1                             25% grey
;       $2                             50% grey
;       $3                             75% grey
;       $4                             100% grey
;       $5                             Small square
;       $6                             Medium square
;       $7                             Large square
;       $8                             One fourth
;       $9                             One half
;       $:                             Top of integral
;       $;                             Bottom of integral
;       $<   <                          Not available in DOS
;       $=   =                          Not available in DOS
;       $>   >                          Not available in DOS
;       $?                             Open question
;       $@   ^[[                        ANSI prefix
;       $A   ^A                         SOH
;       $B   ^B                         STX
;       $C   ^C                         ETX
;       $D   ^D                         EOT
;       $E   ^E                         ENQ
;       $F   ^F                         ACK
;       $G   ^G                         BEL
;       $H   ^H                         BS
;       $I   ^I                         HT
;       $J   ^J                         LF
;       $K   ^K                         VT
;       $L   ^L                         FF
;       $M   ^M                         CR
;       $N   ^N                         SO
;       $O   ^O                         SI
;       $P   ^P                         DLE
;       $Q   ^Q                         DC1
;       $R   ^R                         DC2
;       $S   ^S                         DC3
;       $T   ^T                         DC4
;       $U   ^U                         NAK
;       $V   ^V                         SYN
;       $W   ^W                         ETB
;       $X   ^X                         CAN
;       $Y   ^Y                         EM
;       $Z   ^Z                         SUB
;       $[   ^[                         ESC
;       $\   ^\                         FS
;       $]   ^]                         GS
;       $^   ^^                         RS
;       $_   ^M^J                       CR/LF
;       $`   ^[[                        ANSI prefix
;       $a   a
;       $b   |                          Vertical bar
;       $c   ^[[2J                      ANSI ClScrn
;       $d   ^[[K                       ANSI ClEOLn
;       $e   ^[                         ESC
;       $f                             Function
;       $g   >                          Greater than
;       $h   ^H                         BS
;       $i   ^[[1A                      ANSI up one
;       $j   ^[[1D                      ANSI left one
;       $k   ^[[1C                      ANSI right one
;       $l   <                          Less than
;       $m   ^[[1B                      ANSI down one
;       $n   n
;       $o   o
;       $p   p
;       $q   =                          Equal to
;       $r   ^[[u                       Restore cursor position
;       $s   ^[[s                       Save cursor position
;       $t   t
;       $u   u
;       $v   v
;       $w   ^[[6n                      Cursor location to CRT
;       $x   ^[[R                       Cursor location to KBD
;       $y                             Yen
;       $z                             Cent
;       ${                             Less than or equal to
;       $|   |                          Not available in DOS
;       $}                             Greater than or eual to
;       $~                             About equal to
;       $   The Doctor's BatWrite...   Version number / Program ID / Help
;
; Traanslations table arrangement...
;
;                   String (zero terminated)             Hex  Character
;                   ------------------------------------ ---- ---------
XLTable   db        000h                                 ;$00 ^@
          db        1,0                                  ;$01 ^A
          db        2,0                                  ;$02 ^B
          db        3,0                                  ;$03 ^C
          db        4,0                                  ;$04 ^D
          db        5,0                                  ;$05 ^E
          db        6,0                                  ;$06 ^F
          db        7,0                                  ;$07 ^G
          db        8,0                                  ;$08 ^H
          db        9,0                                  ;$09 ^I
          db        10,0                                 ;$0A ^J
          db        11,0                                 ;$0B ^K
          db        12,0                                 ;$0C ^L
          db        13,0                                 ;$0D ^M
          db        14,0                                 ;$0E ^N
          db        15,0                                 ;$0F ^O

          db        16,0                                 ;$10 ^P
          db        17,0                                 ;$11 ^Q
          db        18,0                                 ;$12 ^R
          db        19,0                                 ;$13 ^S
          db        20,0                                 ;$14 ^T
          db        21,0                                 ;$15 ^U
          db        22,0                                 ;$16 ^V
          db        23,0                                 ;$17 ^W
          db        24,0                                 ;$18 ^X
          db        25,0                                 ;$19 ^Y
          db        26,0                                 ;$1A ^Z
          db        27,0                                 ;$1B ^[
          db        28,0                                 ;$1C ^\
          db        29,0                                 ;$1D ^]
          db        30,0                                 ;$1E ^^
          db        31,0                                 ;$1F ^_

          db        9,0                                  ;$20
          db        "",0                                ;$21  !
          db        '"',0                                ;$22  "
          db        "",0                                ;$23  #
          db        "$",0                                ;$24  $
          db        "%",0                                ;$25  %
          db        "&",0                                ;$26  &
          db        "'",0                                ;$27  '
          db        "",0                                ;$28  (
          db        "",0                                ;$29  )
          db        "",0                                ;$2A  *
          db        "+",0                                ;$2B  +
          db        ",",0                                ;$2C  ,
          db        "",0                                ;$2D  -
          db        ".",0                                ;$2E  .
          db        "/",0                                ;$2F  /

          db        " ",0                                ;$30  0
          db        "",0                                ;$31  1
          db        "",0                                ;$32  2
          db        "",0                                ;$33  3
          db        "",0                                ;$34  4
          db        "",0                                ;$35  5
          db        "",0                                ;$36  6
          db        "",0                                ;$37  7
          db        "",0                                ;$38  8
          db        "",0                                ;$39  9
          db        "",0                                ;$3A  :
          db        "",0                                ;$3B  ;
          db        "<",0                                ;$3C  <
          db        "=",0                                ;$3D  =
          db        ">",0                                ;$3E  >
          db        "",0                                ;$3F  ?

          db        27,"[",0                             ;$40  @
          db        1,0                                  ;$41  A
          db        2,0                                  ;$42  B
          db        3,0                                  ;$43  C
          db        4,0                                  ;$44  D
          db        5,0                                  ;$45  E
          db        6,0                                  ;$46  F
          db        7,0                                  ;$47  G
          db        8,0                                  ;$48  H
          db        9,0                                  ;$49  I
          db        10,0                                 ;$4A  J
          db        11,0                                 ;$4B  K
          db        12,0                                 ;$4C  L
          db        13,0                                 ;$4D  M
          db        14,0                                 ;$4E  N
          db        15,0                                 ;$4F  O

          db        16,0                                 ;$50  P
          db        17,0                                 ;$51  Q
          db        18,0                                 ;$52  R
          db        19,0                                 ;$53  S
          db        20,0                                 ;$54  T
          db        21,0                                 ;$55  U
          db        22,0                                 ;$56  V
          db        23,0                                 ;$57  W
          db        24,0                                 ;$58  X
          db        25,0                                 ;$59  Y
          db        26,0                                 ;$5A  Z
          db        27,0                                 ;$5B  [
          db        28,0                                 ;$5C  \
          db        29,0                                 ;$5D  ]
          db        30,0                                 ;$5E  ^
          db        13,10,0                              ;$5F  _

          db        27,"[",0                             ;$60  `
          db        "a",0                                ;$65  a
          db        "|",0                                ;$61  b
          db        27,"[2J",0                           ;$62  c
          db        27,"[K",0                            ;$63  d
          db        27,0                                 ;$65  e
          db        "",0                                ;$66  f
          db        ">",0                                ;$67  g
          db        8,0                                  ;$68  h
          db        27,"[1A",0                           ;$69  i
          db        27,"[1D",0                           ;$6A  j
          db        27,"[1C",0                           ;$6B  k
          db        "<",0                                ;$6C  l
          db        27,"[1B",0                           ;$6D  m
          db        "n",0                                ;$6E  n
          db        "o",0                                ;$6F  o

          db        "p",0                                ;$70  p
          db        "=",0                                ;$71  q
          db        27,"[u",0                            ;$72  r
          db        27,"[s",0                            ;$73  s
          db        "t",0                                ;$74  t
          db        "u",0                                ;$75  u
          db        "v",0                                ;$76  v
          db        27,"[6n",0                           ;$77  w
          db        27,"[R",0                            ;$78  x
          db        "",0                                ;$79  y
          db        "",0                                ;$7A  z
          db        "",0                                ;$7B  {
          db        "|",0                                ;$7C  |
          db        "",0                                ;$7D  }
          db        "",0                                ;$7E  ~
MyTitle:  db        13,10                                ;$7F  
          db        "The Doctor presents... BatWrite "   ;
          db        "(1.2) batch-file output utility"    ;
          db        13,10,13,10                          ;
          db        "Command syntax is : BATWRITE "      ;
          db        "[data]",13,10,13,10                 ;
          db        "If you do not include data to "     ;
          db        "display, this will be displayed.  " ;
          db        "You can",13,10                      ;
          db        "also use DOS prompt-like `$' "      ;
          db        "options to display pre-defined "    ;
          db        "strings.",13,10                     ;
          db        "Please see the documentation for "  ;
          db        "information on which strings are "  ;
          db        "pre-defined",13,10                  ;
          db        "and how to change them."            ;
          db        13,10,0                              ;

          db        080h,0                               ;$80  
          db        081h,0                               ;$81  
          db        082h,0                               ;$82  
          db        083h,0                               ;$83  
          db        084h,0                               ;$84  
          db        085h,0                               ;$85  
          db        086h,0                               ;$86  
          db        087h,0                               ;$87  
          db        088h,0                               ;$88  
          db        089h,0                               ;$89  
          db        08Ah,0                               ;$8A  
          db        08Bh,0                               ;$8B  
          db        08Ch,0                               ;$8C  
          db        08Dh,0                               ;$8D  
          db        08Eh,0                               ;$8E  
          db        08Fh,0                               ;$8F  

          db        090h,0                               ;$90  
          db        091h,0                               ;$91  
          db        092h,0                               ;$92  
          db        093h,0                               ;$93  
          db        094h,0                               ;$94  
          db        095h,0                               ;$95  
          db        096h,0                               ;$96  
          db        097h,0                               ;$97  
          db        098h,0                               ;$98  
          db        099h,0                               ;$99  
          db        09Ah,0                               ;$9A  
          db        09Bh,0                               ;$9B  
          db        09Ch,0                               ;$9C  
          db        09Dh,0                               ;$9D  
          db        09Eh,0                               ;$9E  
          db        09Fh,0                               ;$9F  

          db        0A0h,0                               ;$A0  
          db        0A1h,0                               ;$A1  
          db        0A2h,0                               ;$A2  
          db        0A3h,0                               ;$A3  
          db        0A4h,0                               ;$A4  
          db        0A5h,0                               ;$A5  
          db        0A6h,0                               ;$A6  
          db        0A7h,0                               ;$A7  
          db        0A8h,0                               ;$A8  
          db        0A9h,0                               ;$A9  
          db        0AAh,0                               ;$AA  
          db        0ABh,0                               ;$AB  
          db        0ACh,0                               ;$AC  
          db        0ADh,0                               ;$AD  
          db        0AEh,0                               ;$AE  
          db        0AFh,0                               ;$AF  

          db        0B0h,0                               ;$B0  
          db        0B1h,0                               ;$B1  
          db        0B2h,0                               ;$B2  
          db        0B3h,0                               ;$B3  
          db        0B4h,0                               ;$B4  
          db        0B5h,0                               ;$B5  
          db        0B6h,0                               ;$B6  
          db        0B7h,0                               ;$B7  
          db        0B8h,0                               ;$B8  
          db        0B9h,0                               ;$B9  
          db        0BAh,0                               ;$BA  
          db        0BBh,0                               ;$BB  
          db        0BCh,0                               ;$BC  
          db        0BDh,0                               ;$BD  
          db        0BEh,0                               ;$BE  
          db        0BFh,0                               ;$BF  

          db        0C0h,0                               ;$C0  
          db        0C1h,0                               ;$C1  
          db        0C2h,0                               ;$C2  
          db        0C3h,0                               ;$C3  
          db        0C4h,0                               ;$C4  
          db        0C5h,0                               ;$C5  
          db        0C6h,0                               ;$C6  
          db        0C7h,0                               ;$C7  
          db        0C8h,0                               ;$C8  
          db        0C9h,0                               ;$C9  
          db        0CAh,0                               ;$CA  
          db        0CBh,0                               ;$CB  
          db        0CCh,0                               ;$CC  
          db        0CDh,0                               ;$CD  
          db        0CEh,0                               ;$CE  
          db        0CFh,0                               ;$CF  

          db        0D0h,0                               ;$D0  
          db        0D1h,0                               ;$D1  
          db        0D2h,0                               ;$D2  
          db        0D3h,0                               ;$D3  
          db        0D4h,0                               ;$D4  
          db        0D5h,0                               ;$D5  
          db        0D6h,0                               ;$D6  
          db        0D7h,0                               ;$D7  
          db        0D8h,0                               ;$D8  
          db        0D9h,0                               ;$D9  
          db        0DAh,0                               ;$DA  
          db        0DBh,0                               ;$DB  
          db        0DCh,0                               ;$DC  
          db        0DDh,0                               ;$DD  
          db        0DEh,0                               ;$DE  
          db        0DFh,0                               ;$DF  

          db        0E0h,0                               ;$E0  
          db        0E1h,0                               ;$E1  
          db        0E2h,0                               ;$E2  
          db        0E3h,0                               ;$E3  
          db        0E4h,0                               ;$E4  
          db        0E5h,0                               ;$E5  
          db        0E6h,0                               ;$E6  
          db        0E7h,0                               ;$E7  
          db        0E8h,0                               ;$E8  
          db        0E9h,0                               ;$E9  
          db        0EAh,0                               ;$EA  
          db        0EBh,0                               ;$EB  
          db        0ECh,0                               ;$EC  
          db        0EDh,0                               ;$ED  
          db        0EEh,0                               ;$EE  
          db        0EFh,0                               ;$EF  

          db        0F0h,0                               ;$F0  
          db        0F1h,0                               ;$F1  
          db        0F2h,0                               ;$F2  
          db        0F3h,0                               ;$F3  
          db        0F4h,0                               ;$F4  
          db        0F5h,0                               ;$F5  
          db        0F6h,0                               ;$F6  
          db        0F7h,0                               ;$F7  
          db        0F8h,0                               ;$F8  
          db        0F9h,0                               ;$F9  
          db        0FAh,0                               ;$FA  
          db        0FBh,0                               ;$FB  
          db        0FCh,0                               ;$FC  
          db        0FDh,0                               ;$FD  
          db        0FEh,0                               ;$FE  
          db        0FFh,0                               ;$FF  [255]

          db        ": End of data. The rest of this is padding :"

;
; This is so the program fills to the end of the sector.
;
Fill:     if ($-Start) mod 512
           db (512-(($-Start) mod 512)) dup (000h)
          endif

Code      ends
          end       Start
